- NAME
- SYNOPSIS
- FUNCTION DESCRIPTIONS

- CharcoalImage
- ColorizeImage
- ConvolveImage
- ImplodeImage
- MorphImages
- OilPaintImage
- SolarizeImage
- SteganoImage
- StereoImage
- SwirlImage
- WaveImage

# NAME

fx - Image special effects methods

# SYNOPSIS

Image * CharcoalImage( const Image *image, const double radius, const double sigma, ExceptionInfo *exception );

Image * ColorizeImage( const Image *image, const char *opacity, const PixelPacket target, ExceptionInfo *exception );

Image * ConvolveImage( const Image *image, const unsigned int order, const double *kernel, ExceptionInfo *exception );

Image * ImplodeImage( const Image *image, const double amount, ExceptionInfo *exception );

Image * MorphImages( const Image *image, const unsigned long number_frames, ExceptionInfo *exception );

Image * OilPaintImage( const Image *image, const double radius, ExceptionInfo *exception );

unsigned int SolarizeImage( Image *image, const double threshold );

Image * SteganoImage( const Image *image, Image *watermark, ExceptionInfo *exception );

Image * StereoImage( const Image *image, const Image *offset_image, ExceptionInfo *exception );

Image * SwirlImage( const Image *image, double degrees, ExceptionInfo *exception );

Image * WaveImage( const Image *image, const double amplitude, const double wave_length, ExceptionInfo *exception );

# FUNCTION DESCRIPTIONS

## CharcoalImage

Method CharcoalImage creates a new image that is a copy of an existing one with the edge highlighted. It allocates the memory necessary for the new Image structure and returns a pointer to the new image.

The format of the CharcoalImage method is:

> Image *CharcoalImage ( const Image *image, const double radius, const double sigma, ExceptionInfo *exception );

A description of each parameter follows:

charcoal_image:
  Method CharcoalImage returns a pointer to the image after it is embossed. A null image is returned if there is a memory shortage.

image:
  The image.

radius:
  the radius of the pixel neighborhood.

sigma:
  The standard deviation of the Gaussian, in pixels.

exception:
  Return any errors or warnings in this structure.

## ColorizeImage

> ColorizeImage() blends the fill color with each pixel in the image. A percentage blend is specified with opacity. Control the application of different color components by specifying a different percentage for

The format of the ColorizeImage method is:

> Image *ColorizeImage ( const Image *image, const char *opacity, const PixelPacket target, ExceptionInfo *exception );

A description of each parameter follows:

image:
  The image.

opacity:
  A character string indicating the level of opacity as a percentage.

target:
  A color value.

exception:
  Return any errors or warnings in this structure.

## ConvolveImage

> ConvolveImage() applies a custom convolution kernel to the image.

The format of the ConvolveImage method is:

> Image *ConvolveImage ( const Image *image, const unsigned int order, const double *kernel, ExceptionInfo *exception );

A description of each parameter follows:

image:
  The image.

order:
  The number of columns and rows in the filter kernel.

kernel:
  An array of double representing the convolution kernel.

exception:
  Return any errors or warnings in this structure.

## ImplodeImage

Method ImplodeImage creates a new image that is a copy of an existing one with the image pixels ``implode'' by the specified percentage. It allocates the memory necessary for the new Image structure and returns a pointer to the new image.

The format of the ImplodeImage method is:

> Image *ImplodeImage ( const Image *image, const double amount, ExceptionInfo *exception );

A description of each parameter follows:

implode_image:
  Method ImplodeImage returns a pointer to the image after it is implode. A null image is returned if there is a memory shortage.

image:
  The image.

amount:
  Define the extent of the implosion.

exception:
  Return any errors or warnings in this structure.

## MorphImages

> The MorphImages() method requires a minimum of two images. The first image is transformed into the second by a number of intervening images as specified by frames.

The format of the MorphImage method is:

> Image *MorphImages ( const Image *image, const unsigned long number_frames, ExceptionInfo *exception );

A description of each parameter follows:

image:
  The image.

number_frames:
  Define the number of in-between image to generate. The more in-between frames, the smoother the morph.

exception:
  Return any errors or warnings in this structure.

## OilPaintImage

> OilPaintImage() applies a special effect filter that simulates an oil painting. Each pixel is replaced by the most frequent color occurring in a circular region defined by radius.

The format of the OilPaintImage method is:

> Image *OilPaintImage ( const Image *image, const double radius, ExceptionInfo *exception );

A description of each parameter follows:

image:
  The image.

radius:
  The radius of the circular neighborhood.

exception:
  Return any errors or warnings in this structure.

## SolarizeImage

> SolarizeImage() applies a special effect to the image, similar to the effect achieved in a photo darkroom by selectively exposing areas of photo sensitive paper to light. Threshold ranges from 0 to MaxRGB and is a measure of the extent of the solarization. False is returned if an error is encountered.

The format of the SolarizeImage method is:

> unsigned int SolarizeImage ( Image *image, const double threshold );

A description of each parameter follows:

image:
  The image.

threshold:
  Define the extent of the solarization.

## SteganoImage

> Use SteganoImage() to hide a digital watermark within the image. Recover the hidden watermark later to prove that the authenticity of an image. Offset defines the start position within the image to hide the watermark.

The format of the SteganoImage method is:

> Image *SteganoImage ( const Image *image, Image *watermark, ExceptionInfo *exception );

A description of each parameter follows:

image:
  The image.

watermark:
  The watermark image.

exception:
  Return any errors or warnings in this structure.

## StereoImage

> StereoImage() combines two images and produces a single image that is the composite of a left and right image of a stereo pair. Special red-green stereo glasses are required to view this effect.

The format of the StereoImage method is:

> Image *StereoImage ( const Image *image, const Image *offset_image, ExceptionInfo *exception );

A description of each parameter follows:

stereo_image:
  Method StereoImage returns a pointer to the stereo image. A null image is returned if there is a memory shortage.

image:
  The image.

offset_image:
  Another image.

exception:
  Return any errors or warnings in this structure.

## SwirlImage

> SwirlImage() swirls the pixels about the center of the image, where degrees indicates the sweep of the arc through which each pixel is moved. You get a more dramatic effect as the degrees move from 1 to 360.

The format of the SwirlImage method is:

> Image *SwirlImage ( const Image *image, double degrees, ExceptionInfo *exception );

A description of each parameter follows:

image:
  The image.

degrees:
  Define the tightness of the swirling effect.

exception:
  Return any errors or warnings in this structure.

## WaveImage

> The WaveImage() filter creates a "ripple" effect in the image by shifting the pixels vertically along a sine wave whose amplitude and wavelength is specified by the given parameters.

The format of the WaveImage method is:

> Image *WaveImage ( const Image *image, const double amplitude, const double wave_length, ExceptionInfo *exception );

A description of each parameter follows:

image:
  The image.

amplitude, frequency:
  Define the amplitude and wave_length of the sine wave.

exception:
  Return any errors or warnings in this structure.